﻿angular.module('fwapp.controllers')

// 在线问诊/复诊诊疗
.controller('ConsultationController', function ($scope, $rootScope, $state, $stateParams, $interval, $timeout, $http
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet
, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaGeolocation, $cordovaInAppBrowser, $fwCordovaToast, $filter
, ConsultationService, DoctorInfoService, UploadImgService, RequestService, SrvyService, VisitPatientService, OpApptService) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 定义在线问诊/复诊诊疗滑块
    var slideConsultation = $ionicSlideBoxDelegate.$getByHandle('slideConsultation');
    // 服务开关
    $scope.isServerOn = true;
    // 初始滑块状态
    $scope.step = 0;
    // 传入就诊人ID
    $scope.inVpid = $stateParams.vpid;
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 医师列表
    $scope.doctorList = [];
    $scope.doctorListEmpty = false;
    // 选中医师信息
    $scope.selectDoctor = new Object();
    // 支付记录id
    $scope.applyId = "";
    // 是否为复诊患者
    $scope.IsConsultation = "0";
    // 仅看可咨询
    $scope.showAvailable = false;
    // 按医师搜索
    $scope.doctorSearch = {};
    $scope.doctorSearch.list = []; // 医师搜索结果列表
    $scope.doctorSearch.keyword = ""; // 医师搜索关键词
    $scope.doctorSearch.isSearch = false;  // 是否搜索
    $scope.doctorSearch.isEmpty = false;  // 结果是否空
    // 配置Config
    $scope.configData = {};
    // 选择科别code
    $scope.divisionCode = "";
    // 页面是否加载完毕
    $scope.isLoadFinish = false;
    // titleName
    $scope.titleName = "在线问诊";
    // 病情信息对象
    $scope.infomation = {};
    $scope.infomation.infomation = ""; // 病情描述
    $scope.infomation.help = ""; // 希望获得的帮助
    $scope.infomation.visitHospital = ""; // 已就诊医院及科室
    $scope.infomation.isDrug = 0; // 用药情况，1=有，0=无
    $scope.infomation.drug = ""; // 用药情况
    $scope.infomation.isAllergy = 0; //过敏史，1=有，0=无
    $scope.infomation.allergy = ""; //过敏史
    $scope.infomation.isPreviousDisease = 0; //既往病史，1=有，0=无
    $scope.infomation.previousDisease = ""; // 既往病史
    $scope.infomation.imgList = []; // 图片URL
    $scope.infomation.purpose = ""; // 咨询目的
    $scope.infomation.guardianName = "";// 监护人姓名
    $scope.infomation.guardianPhone = "";// 监护人手机号
    $scope.infomation.disease = [];// 所患疾病数组
    $scope.infomation.diseaseStr = "";// 所患疾病显示字符串
    // 大图列表
    $scope.uploadImgList = [];
    // 图片服务器路径
    $scope.imgServerUrl = uploadUrl;
    $scope.slides = [];
    $scope.currentImgIndex = 0;
    $scope.currentSlideIndex = 0;
    // 病情信息Id
    $scope.infomationId = "";
    // 病情信息历史记录
    $scope.infomationHistoryList = [];
    // 是否需要支付
    $scope.needPay = true;
    // 本次咨询目的数组
    $scope.purposeList = [];
    // 咨询目的其他的是否展示
    $scope.purposeOtherShow = false;
    // 从哪进来的,1=按科室预约，2=按病区预约
    $scope.fromDivision = 0;
    // 病区
    $scope.doctorDivision = {};
    $scope.doctorDivision.name = "";
    $scope.doctorDivision.code = "";
    // 模板内容
    $scope.tmpl = new Object();
    // 模板信息
    $scope.tmplInfo = new Object();
    // 总题数
    $scope.qstnCount = 0;
    // 问卷结果
    $scope.srvyResult = new Object();
    // 当前问卷ID
    $scope.currentRec = new Object();
    // 疾病查询
    $scope.addDiseaseData = {};
    $scope.addDiseaseData.keyword = '';
    // 知情同意书
    $scope.informedConsent = {};
    $scope.informedConsent.agree = false;
    // 是否选择医师
    $scope.chooseDoctor = false;
    // 是否显示用药情况选择
    $scope.drugRadioShow = true;
    // 记录request的次数
    $scope.requestNum = 0;
    // 选择病区/病种/技术title
    $scope.groupTitleName = "";
    // 选中的病种/技术
    $scope.group = {};

    // 注册模态窗口：医师介绍
    $ionicModal.fromTemplateUrl('templates/doctorIntro.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.doctorIntroModal = modal;
    });

    // 大图浏览
    $ionicModal.fromTemplateUrl("popup_image.html", {
        scope: $scope,
        animation: "fade-in"
    }).then(function (modal) {
        $scope.popupImageModal = modal;
    });

    // 病情信息历史记录
    $ionicModal.fromTemplateUrl("infomationHistory.html", {
        scope: $scope
    }).then(function (modal) {
        $scope.infomationHistory = modal;
    });

    // 注册模态窗口：放大显示头像
    $ionicModal.fromTemplateUrl('templates/showAvatar.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.showAvatarModal = modal;
    });

    // 注册模态窗口：量表评估
    $ionicModal.fromTemplateUrl('templates/srvyTmpl.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.srvyModal = modal;
    });

    // 注册模态窗口：选择疾病
    $ionicModal.fromTemplateUrl('infomationDisease.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.infomationDiseaseModal = modal;
    });

    // 注册模态窗口：搜索疾病
    $ionicModal.fromTemplateUrl('addDisease.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.addDiseaseModal = modal;
    });

    // 注册模态窗口：知情同意书
    $ionicModal.fromTemplateUrl('informedConsent.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.informedConsentModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.doctorIntroModal.remove();
        $scope.popupImageModal.remove();
        $scope.infomationHistory.remove();
        $scope.showAvatarModal.remove();
        $scope.srvyModal.remove();
        $scope.infomationDiseaseModal.remove();
        $scope.addDiseaseModal.remove();
        $scope.informedConsentModal.remove();
    })

    // 滑到上一步
    $scope.lastSlide = function () {
        slideConsultation.previous();
        $scope.step = slideConsultation.currentIndex();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideConsultation.next();
        $scope.step = slideConsultation.currentIndex();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideConsultation.slide(index);
        $scope.step = slideConsultation.currentIndex();
        console.log("toSlide =>" + index);
    }

    // 查询可问诊医师列表
    $scope.loadDoctorList = function () {
        $ionicLoading.show();
        $scope.doctorListEmpty = false;
        $scope.doctorList = [];

        // 2020年7月23日14:02:28 HM 增加药师咨询列表
        var doctorType = 1;
        if($scope.fromDivision == 3){
            doctorType = 2;
        }
        else if($scope.fromDivision == 4){
            doctorType = 3;
        }

        ConsultationService.getDoctorList($scope.showAvailable, $scope.doctorSearch.keyword, $scope.divisionCode, $scope.doctorDivision.code, doctorType, $scope.group.GROUP_CODE, $scope.group.GROUP_TYPE).then(function (data) {
            if (data.result == 1) {
                console.log(data.data);
                $scope.doctorList = data.data;

                if ($scope.doctorList.length == 0) {
                    $scope.doctorListEmpty = true;
                    // 直接选医生
                    $scope.toSlide(2);
                    // 重新计算高度
                    $ionicScrollDelegate.resize();
                    $ionicLoading.hide();

                    return;
                }

                if(doctorType == 2){
                    // 如果选择的是药师咨询，判断是否给他选择医师
                    $scope.chooseDoctor = data.chooseDoctor;
                    if($scope.chooseDoctor == true){
                        $scope.checkData(0);
                    }
                    else{
                        // 直接选医生
                        $scope.toSlide(2);
                    }
                }    
            }
            else {
                $scope.doctorListEmpty = true;
            }
            // 重新计算高度
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        }, function () {
            $scope.doctorListEmpty = true;
            $ionicLoading.hide();
        })
    }

    // 选医生后，填写病情信息
    $scope.checkData = function (index) {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        $ionicLoading.show();
        // 初始化变量
        $scope.applyId = "";
        $scope.needPay = true;
        $scope.infomationId = "";
        $scope.infomation = {};
        $scope.infomation.disease = []; // 所患疾病数组
        $scope.infomation.diseaseStr = "";// 所患疾病字符串
        $scope.infomation.infomation = ""; // 病情描述
        $scope.infomation.help = ""; // 希望获得的帮助
        $scope.infomation.visitHospital = ""; // 已就诊医院及科室
        $scope.infomation.isDrug = 0; // 用药情况，1=有，0=无
        $scope.infomation.drug = ""; // 用药情况
        $scope.infomation.isAllergy = 0; //过敏史，1=有，0=无
        $scope.infomation.allergy = ""; //过敏史
        $scope.infomation.isPreviousDisease = 0; //既往病史，1=有，0=无
        $scope.infomation.previousDisease = ""; // 既往病史
        $scope.infomation.imgList = []; // 图片URL
        $scope.infomationHistoryList = [];
        $scope.infomation.purpose = "";
        $scope.infomation.guardianName = "";// 监护人名称
        $scope.infomation.guardianPhone = "";// 监护人手机号
        $scope.infomation.currentAreaCode = "";// 行政区划
        $scope.purposeOtherShow = false;
        for(var i=0;i<$scope.purposeList.length;i++){
            $scope.purposeList[i].status = "0";
        }

        $scope.selectDoctor = $scope.doctorList[index];
        if ($scope.selectDoctor.TREAT_FEE == -1) {
            $scope.needPay = false;
        }
        // 先验证一下，阜外当前有没有会话
        ConsultationService.consultationStatus($scope.inVpid, $scope.selectDoctor.DOCTOR_CODE).then(function (data) {
            // 有会话
            if (data.result == 1) {
                $ionicLoading.hide();
                // 调易复诊sdk，进下一页吧
                $scope.applyId = data.applyId;
                $scope.needPay = false;
                $scope.toSlide(4);
            }
            // 没会话
            else if (data.result == 2) {
                if($scope.fromDivision == 4){
                    ConsultationService.checkOLCondition($scope.inVpid).then(function (dataCon){
                        if(dataCon.result == 0){
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom(dataCon.msg);
                        }
                        else{
                            if(dataCon.status == 1){
                                $scope.getInfomationList();
                            }
                            // 同意
                            else if(dataCon.status == 3){
                                $ionicLoading.hide();
                                var confirmPopup = $ionicPopup.confirm({
                                    title: "提示",
                                    template: dataCon.msg,
                                    okText: "复诊续方",
                                    cancelText: "取消"
                                });
                                // 继续, 跳转
                                confirmPopup.then(function (res) {
                                    if (res) {
                                        $state.go("app.olTreatRecipe", { from: "consultation" });
                                    }
                                })
                            }
                            // 拒绝
                            else{
                                $ionicLoading.hide();
                                var confirmPopup = $ionicPopup.confirm({
                                    title: "提示",
                                    template: dataCon.msg,
                                    okText: "预约挂号",
                                    cancelText: "取消"
                                });
                                // 继续, 跳转
                                confirmPopup.then(function (res) {
                                    if (res) {
                                        $state.go("app.opAppt");
                                    }
                                })
                            }
                        }
                    }, function () {
                        $ionicLoading.hide();
                        $fwCordovaToast.showShortBottom("获取复诊续方资质延长，网络错误");
                    })
                }
                else{
                    $scope.getInfomationList();
                }
            }
            // 报错了
            else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("获取阜外会话，网络错误");
        })
    }

    // 获取病情信息，提出公共方法
    $scope.getInfomationList = function (){
        // 跳转页面，先获取病情信息，然后让患者点击是否继续填写
        ConsultationService.getInfomationList($scope.inVpid).then(function (dataInfomation) {
            $scope.toSlide(3);
            $ionicLoading.hide();
            // 有未关联的病情信息
            if (dataInfomation.result == 1) {
                $ionicPopup.confirm({
                    title: "继续填写",
                    template: "您是否要继续填写病情信息？",
                    cancelText: "否",
                    okText: "是"
                }).then(function (res) {
                    $ionicLoading.show();
                    $scope.requestNum = 0;
                    if (res) {
                        $scope.infomation.diseaseStr = dataInfomation.saveInfomation.DISEASE; // 所患疾病字符串
                        $scope.infomation.infomation = dataInfomation.saveInfomation.INFOMATION; // 病情描述
                        $scope.infomation.help = dataInfomation.saveInfomation.HELP; // 希望获得的帮助
                        $scope.infomation.visitHospital = dataInfomation.saveInfomation.VISIT_HOSPITAL; // 已就诊医院及科室
                        $scope.infomation.isDrug = dataInfomation.saveInfomation.IS_DRUG; // 用药情况，1=有，0=无
                        $scope.infomation.drug = dataInfomation.saveInfomation.DRUG; // 用药情况
                        $scope.infomation.isAllergy = dataInfomation.saveInfomation.IS_ALLERGY; //过敏史，1=有，0=无
                        $scope.infomation.allergy = dataInfomation.saveInfomation.ALLERGY; //过敏史
                        $scope.infomation.isPreviousDisease = dataInfomation.saveInfomation.IS_PREVIOUS_DISEASE; //既往病史，1=有，0=无
                        $scope.infomation.previousDisease = dataInfomation.saveInfomation.PREVIOUS_DISEASE; // 既往病史
                        $scope.infomation.purpose = dataInfomation.saveInfomation.PURPOSE;
                        $scope.infomation.guardianName = dataInfomation.saveInfomation.GUARDIAN_NAME;// 监护人姓名
                        $scope.infomation.guardianPhone = dataInfomation.saveInfomation.GUARDIAN_PHONE;// 监护人手机号
                        $scope.infomation.currentAreaCode = dataInfomation.saveInfomation.CURRENT_AREA_CODE;// 行政区划
                        $scope.infomation.disease = dataInfomation.saveInfomation.DISEASE_LIST; // 所患疾病数组
                                
                        // 判断是否为undefined
                        if (typeof $scope.infomation.disease == 'undefined') {
                            $scope.infomation.disease = [];
                        }

                        var purposeStr = new Array();
                        purposeStr = dataInfomation.saveInfomation.PURPOSE.split("；");

                        $scope.infomation.purpose = "";
                        for(var i=0;i<$scope.purposeList.length;i++){
                            // 2020-8-3 09:02:39 HM 如果是药师咨询，就跳过
                            if($scope.purposeList[i].way == "3" || $scope.purposeList[i].way == "4"){
                                continue;
                            }

                            $scope.purposeList[i].status = "0";
                            for(var j=0;j<purposeStr.length;j++){
                                if(purposeStr[j] == $scope.purposeList[i].name){
                                    $scope.purposeList[i].status = "1";
                                }
                            }

                            $scope.purposeOtherShow = false;
                            if($scope.purposeList[i].code == "999" && $scope.purposeList[i].status == "1"){
                                $scope.purposeOtherShow = true;
                            }

                            if($scope.purposeList[i].status == "1"){
                                $scope.infomation.purpose += $scope.purposeList[i].name + "；";
                            }
                        }

                        $scope.infomationId = dataInfomation.saveInfomation.TREAT_INFOMATION_ID;
                        UploadImgService.imgList("BY_CONSULTATION", $scope.infomationId).then(function (imgData) {
                            $scope.requestNum++;
                            // 2020-12-21 10:19:49 HM 这里request比较多，有异步的，都走完后，要消loading
                            if($scope.requestNum == 2){
                                $ionicLoading.hide();
                            }

                            if (imgData.result == 0) {
                                $fwCordovaToast.showShortBottom(imgData.msg);
                            } else {
                                $scope.infomation.imgList = imgData.data;
                                $ionicScrollDelegate.resize();
                            }
                        }, function (data) {
                            $ionicLoading.hide();
                            $fwCordovaToast.showShortBottom("获取图片列表，请稍后再试");
                        })

                        // 如果是复诊续方资质延长，根据最后一个【其他用药情况：】排除
                        console.log($scope.infomation.drug);
                        if($scope.fromDivision == 4){
                            var indexStr = $scope.infomation.drug.lastIndexOf("其他用药情况：");
                            // 如果没找到
                            if(indexStr == -1){
                                $scope.infomation.drug = "";
                                $scope.infomation.isDrug = 0;
                            }
                            else{
                                // 7个字符：其他用药情况：   2个字符\r\n
                                $scope.infomation.drug = $scope.infomation.drug.substring(indexStr + 9);
                            }
                        }
                    }
                    else {
                        // 如果不导入之前的，也就是从空白的开始。走下request，查一下这个患者的上次诊断
                        $scope.getDiseaseResp(dataInfomation.requestId);
                    }
                    $scope.infomationHistoryList = dataInfomation.otherInfomation;

                    // 如果是资质延长，这里查一下他的用药史，且不能修改。
                    $scope.getOpDrug();
                });
            }
            // 无未关联的病情信息
            else if (dataInfomation.result == 2) {
                $ionicLoading.show();
                $scope.requestNum = 0;

                // 没有保存的病情信息，获取历史记录就完事
                // 并没有完事，查一下这个患者的上次诊断
                $scope.getDiseaseResp(dataInfomation.requestId);
                $scope.infomationHistoryList = dataInfomation.otherInfomation;

                // 如果是资质延长，这里查一下他的用药史，且不能修改。
                $scope.getOpDrug();
            }
            else {
                $fwCordovaToast.showShortBottom(dataInfomation.msg);
            }
        }, function () {
            $fwCordovaToast.showShortBottom("获取病情信息，网络错误");
        })
    }

    // 提交病情信息，进行支付操作
    $scope.submitInfomation = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // 其他的对象
        var other = $scope.purposeList.filter(e => e.code == '999');

        // 2020-8-3 08:18:46 HM 如果是药师咨询，本次咨询目的只有药学咨询
        if($scope.fromDivision == 3 || $scope.fromDivision == 4){
            other.status = "0";
            $scope.infomation.help = "";

            var pur = $scope.purposeList.filter(e => e.way == $scope.fromDivision)[0];
            $scope.infomation.purpose = pur.name + "；";
        }
        // 填空判断
        if ($scope.infomation.disease.length == 0) {
            $fwCordovaToast.showShortBottom("请至少选择一项疾病。");
        }
        else if ($scope.infomation.infomation.length < 20) {
            $fwCordovaToast.showShortBottom("病情描述信息不得少于20个字。");
        }
        else if ($scope.infomation.purpose.length == 0) {
            $fwCordovaToast.showShortBottom("本次咨询的目的不能为空。");
        }
        else if (other.status == "1" && $scope.infomation.help.length < 5) {
            $fwCordovaToast.showShortBottom("本次咨询的目的不得少于5个字");
        }
        else if ($scope.infomation.visitHospital.length == 0) {
            $fwCordovaToast.showShortBottom("已就诊医院及科室不能为空。");
        }
        else if ($scope.infomation.isDrug == 1 && $scope.infomation.drug.length == 0) {
            $fwCordovaToast.showShortBottom("用药情况信息不能为空。");
        }
        else if ($scope.infomation.isAllergy == 1 && $scope.infomation.allergy.length == 0) {
            $fwCordovaToast.showShortBottom("过敏史信息不能为空。");
        }
        else if ($scope.infomation.isPreviousDisease == 1 && $scope.infomation.previousDisease.length == 0) {
            $fwCordovaToast.showShortBottom("既往病史信息不能为空。");
        }
        // 判断是否上传图片，要先判断是否有infomationId，还得再判断是否有图片，测试版api开启devmode
        else if (($scope.infomationId == null || $scope.infomationId.length == 0 || $scope.infomation.imgList.length == 0) && devMode == false) {
            $fwCordovaToast.showShortBottom("请上传检查资料。");
        }
        // 如果需要填写监护人信息，但是没有填，弹错误
        else if ($scope.vpInfo.IS_GUARDIAN == 1 && ($scope.infomation.guardianName.length == 0 || $scope.infomation.guardianPhone.length == 0)){
            $fwCordovaToast.showShortBottom("请填写监护人信息。");
        }
        else if ($scope.infomation.currentAreaCode.length == 0){
            $fwCordovaToast.showShortBottom("请选择现住址行政区划。");
        }
        else {
            $ionicLoading.show();
            // 只做提交病情信息这个事，插请求和收费之后再去做，此时的infomationId应该不会为空
            if($scope.infomation.purpose.charAt($scope.infomation.purpose.length - 1) == "；"){
                $scope.infomation.purpose = $scope.infomation.purpose.substr(0, $scope.infomation.purpose.length - 1);
            }

            var diseaseString = "";
            for (var i = 0; i < $scope.infomation.disease.length; i++) {
                if ($scope.infomation.disease[i].RECS_CODE.length != 0) {
                    diseaseString += $scope.infomation.disease[i].DISEASE_NAME + "@" + $scope.infomation.disease[i].RECS_CODE + "|";
                }
                else if ($scope.infomation.disease[i].DISEASE_NAME.length != 0){
                    diseaseString += $scope.infomation.disease[i].DISEASE_NAME + "@0|";
                }
            }
            diseaseString = diseaseString.substr(0, diseaseString.length - 1);
            // 增加疾病格式化判断，保证提交的诊断全是标准化诊断
            if (diseaseString.indexOf("@") == -1){
                $fwCordovaToast.showShortBottom("疾病格式错误，请重新选择疾病");
                return;
            }

            // 如果是复诊续方资质延长
            if($scope.fromDivision == 4){
                $scope.infomation.isDrug = 1;
                if($scope.infomation.drug != "" && $scope.infomation.drug.length > 0){
                    var drugStr = $scope.infomation.drugOL + "\r\n";
                    drugStr += "其他用药情况：\r\n";
                    drugStr += $scope.infomation.drug;
                    $scope.infomation.drug = drugStr;
                }
                else{
                    $scope.infomation.drug = $scope.infomation.drugOL;
                }
            }

            ConsultationService.submitInfomation(diseaseString, $scope.infomation.infomation, $scope.infomation.help, $scope.infomation.visitHospital, 
            $scope.infomation.isDrug, $scope.infomation.drug, $scope.infomation.isAllergy, $scope.infomation.allergy, $scope.infomation.isPreviousDisease, $scope.infomation.previousDisease,
            $scope.infomation.purpose, $scope.inVpid, $scope.selectDoctor.DOCTOR_CODE, $scope.infomationId, "1", 
            $scope.vpInfo.IS_GUARDIAN, $scope.infomation.guardianName, $scope.infomation.guardianPhone, $scope.infomation.currentAreaCode).then(function (data) {
                $ionicLoading.hide();
                if (data.result == 1) {
                    $scope.infomationId = data.data;

                    // API控制，是否填问卷，填哪份问卷
                    if (data.srvy.isSrvy == 1) {
                        console.log("应该跳到体检问卷里了");
                        // 加载模板
                        SrvyService.items(data.srvy.srvyTmpl).then(function (dataSrvy) {
                            $scope.tmpl = dataSrvy.QSTN_LIST;
                            $scope.tmplInfo.name = dataSrvy.TMPL_NAME;
                            $scope.tmplInfo.id = dataSrvy.TMPL_ID;
                            $scope.tmplInfo.display = dataSrvy.TMPL_DISPLAY;
                            $scope.qstnCount = $scope.tmpl.length;

                            $scope.isLoadFinish_Tmpl = true;

                            $ionicScrollDelegate.resize();
                            $ionicScrollDelegate.scrollTop();

                            if ($scope.tmplInfo.display == "SLIDE") {
                                $timeout(function () {
                                    $scope.$broadcast('slideTmplList.init');
                                    $ionicLoading.hide();
                                }, 300);
                            } else {
                                $ionicLoading.hide();
                            }
                        })

                        $scope.srvyList = [];
                        $scope.srvyModal.show();
                    }
                    else {
                        // 插入病情信息成功，跳转
                        $scope.toSlide(4);
                    }
                }
                else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            }, function () {
                $fwCordovaToast.showShortBottom("网络错误");
                $ionicLoading.hide();
            })
        }
    }

    // 立即咨询
    $scope.goConsultation = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        $ionicLoading.show();
		// 2020-9-23 11:26:52 HM 增加复诊续方资质延长，把就诊方式改下
        var consultationWay = 1;
        if($scope.fromDivision == 1 || $scope.fromDivision == 2){
            consultationWay = 1;
        }
        else if($scope.fromDivision == 3){
            consultationWay = 2;
        }
        else if($scope.fromDivision == 4){
            consultationWay = 3;
        }
        // 验证是否有applyId，没有的话创建申请，再验证支付状态，再调易复诊
        if ($scope.applyId == null || $scope.applyId.length == 0) {
            ConsultationService.submitApply($scope.inVpid, $scope.selectDoctor.TREAT_DOCTOR_ID, $scope.IsConsultation, consultationWay).then(function (dataSubmit) {
                $ionicLoading.hide();
                if (dataSubmit.result == 1) {
                    $scope.applyId = dataSubmit.data;
                    // 如果医师服务费为-1，为免费的
                    if ($scope.selectDoctor.TREAT_FEE == -1) {
                        $scope.respApply();
                    }
                    else {
                        //收银台
                        $scope.cashier("consultation", $scope.selectDoctor.TREAT_FEE, $scope.inVpid, $scope.applyId).then(function (dataCashier) {
                            if (dataCashier.code == 1) {
                                $scope.respApply();
                            }
                            else {
                                $scope.applyId = "";
                            }
                        })
                    }
                }
                else {
                    $fwCordovaToast.showShortBottom(dataSubmit.msg);
                }
            }, function () {
                $fwCordovaToast.showShortBottom("网络错误");
            })
        }
        // 调易复诊
        else {
            ConsultationService.getBYStatus($scope.applyId).then(function (data) {
                $ionicLoading.hide();
                if (data.result == 0) {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                // 有会话，会话已经结束
                else if (data.result == 2) {
                    var param = { accountSourceId: localStorage.currentAccountId, accountId: "" };
                    var funcSuccess = function (data) {
                        console.log("百洋：openChatRecord 调用成功");
                        console.log(data);
                    }
                    var funcError = function (data) {
                        console.log("百洋：openChatRecord 调用失败");
                        console.log(data);
                    }

                    window.plugins.EasyChatPlugin.openChatRecord(param, funcSuccess, funcError);
                }
                // 1 = 有会话，正在会话中,3 = 查不到会话
                else if (data.result == 1 || data.result == 3) {
                    var param = {
                        accountSourceId: $scope.vpInfo.ACCOUNT_ID,
                        accountId: $scope.inVpid,
                        patientName: $scope.vpInfo.VISIT_PATIENT_NAME,
                        patientSex: $scope.vpInfo.SEX == '1' ? "男" : "女",
                        patientBirthday: $scope.vpInfo.BIRTHDAY.slice(0, 10),
                        patientHeadPic: $scope.vpInfo.HEAD_PIC,
                        patientPhoneNo: $scope.vpInfo.PHONE_NUM,
                        doctorId: $scope.selectDoctor.DOCTOR_CODE,
                        doctorEmployeeCardNo: $scope.selectDoctor.STAFF_NUMBER, // 胸卡号
                        hospitalOrderId: $scope.applyId,
                        fuzhen: $scope.IsConsultation
                    };

                    var funcSuccess = function (funcData) {
                        console.log('百洋：toChat 调用成功');
                        console.log(funcData);
                    }

                    var funcError = function (funcData) {
                        console.log('百洋：toChat 调用失败');
                        console.log(funcData);
                    }
                    window.plugins.EasyChatPlugin.toChat(param, funcSuccess, funcError);
                }
            })
        }
    }

    // 验证支付状态，调易复诊
    $scope.respApply = function () {
        $ionicLoading.show();
        ConsultationService.respApply($scope.applyId, $scope.infomationId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 1) {
                // 调易复诊sdk
                // 2020-2-6 14:02:52 HM 在线咨询功能修改，这里全部默认为初诊患者，0为初诊、1为就诊
                var param = {
                    accountSourceId: $scope.vpInfo.ACCOUNT_ID,
                    accountId: $scope.inVpid,
                    patientName: $scope.vpInfo.VISIT_PATIENT_NAME,
                    patientSex: $scope.vpInfo.SEX == '1' ? "男" : "女",
                    patientBirthday: $scope.vpInfo.BIRTHDAY.slice(0, 10),
                    patientHeadPic: $scope.vpInfo.HEAD_PIC,
                    patientPhoneNo: $scope.vpInfo.PHONE_NUM,
                    doctorId: $scope.selectDoctor.DOCTOR_CODE,
                    doctorEmployeeCardNo: $scope.selectDoctor.STAFF_NUMBER, // 胸卡号
                    hospitalOrderId: $scope.applyId,
                    fuzhen: $scope.IsConsultation
                };

                var funcSuccess = function (funcData) {
                    console.log('百洋：toChat 调用成功');
                    console.log(funcData);
                }

                var funcError = function (funcData) {
                    console.log('百洋：toChat 调用失败');
                    console.log(funcData);
                }
                window.plugins.EasyChatPlugin.toChat(param, funcSuccess, funcError);
            }
            else if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                $fwCordovaToast.showShortBottom("网络错误");
            }
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误");
            $ionicLoading.hide();
        })
    }

    // 切换可咨询
    $scope.switchShowAvailable = function () {
        $scope.showAvailable = !$scope.showAvailable;
        $scope.loadDoctorList();
    }

    // 搜索医师
    $scope.searchDoctor = function () {
        if ($scope.doctorSearch.keyword == "") {
            $fwCordovaToast.showShortBottom("请输入医生姓名进行搜索");
            return false;
        }
        $scope.doctorSearch.isSearch = true;
        $scope.loadDoctorList();
    }

    // 清空搜索结果
    $scope.clearSearch = function () {
        $scope.doctorSearch.list = new Array();
        $scope.doctorSearch.keyword = "";
        $scope.opApptData.doctorName = "";
        $scope.doctorSearch.isSearch = false;
        $scope.doctorSearch.isEmpty = false;
        $scope.loadDoctorList();
    }

    // 切换科室
    $scope.changeDivision = function (division) {
        $scope.divisionCode = division;
        $scope.loadDoctorList();
    }

    // 病情描述信息切换radio
    $scope.changeRadio = function (str, index) {
        if (str == "isDrug") {
            $scope.infomation.isDrug = index;
            if (index == 0) {
                $scope.infomation.drug = "";
            }
        }
        else if (str == "isAllergy") {
            $scope.infomation.isAllergy = index;
            if (index == 0) {
                $scope.infomation.allergy = "";
            }
        }
        else if (str == "isPreviousDisease") {
            $scope.infomation.isPreviousDisease = index;
            if (index == 0) {
                $scope.infomation.previousDisease = "";
            }
        }
        $ionicScrollDelegate.resize();
    }

    // 图片上传
    $scope.imgAddActionSheet = function () {
        // 显示ActionSheet
        $ionicActionSheet.show({
            titleText: "请选择上传图片方式",
            buttons: [
                { text: '<i class="icon ion-camera"></i> 拍照上传' },
                { text: '<i class="icon ion-image"></i> 由相册选择' }
            ],
            cancelText: "取消",
            cancel: function () {
                return true;
            },
            buttonClicked: function (index) {
                switch (index) {
                    case 0:     // 拍照上传
                        $scope.cameraImg();
                        return true;
                        break;
                    case 1:     // 由相册选择
                        $scope.selectImg();
                        return true;
                        break;
                }
            }
        })
    }

    // 由相册选择图片
    $scope.selectImg = function () {
        var imgCount = 9 - $scope.infomation.imgList.length;
        var options = {
            quality: 100,
            maximumImagesCount: imgCount,
            width: 0,
            height: 0
        };

        $cordovaImagePicker.getPictures(options).then(function (imageDataList) {
            console.log(imageDataList.length);
            $scope.uploadImg(imageDataList);
        }, function (err) {

        });
    }

    // 调用摄像头拍照
    $scope.cameraImg = function () {
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        };

        $cordovaCamera.getPicture(options).then(function (imageData) {
            console.log(imageData);
            var imageDataList = [];
            imageDataList[0] = imageData;
            $scope.uploadImg(imageDataList);
        }, function (err) {

        });
    }

    // 上传图片
    $scope.uploadImg = function (imageDataList) {
        // 没有病情信息ID，证明是新创建的
        if ($scope.infomationId == null || $scope.infomationId.length == 0) {
            // 没有就，建一个病情信息
            ConsultationService.submitInfomation("", "", "", "", 0,
            "", 0, "", 0, "", "",
            $scope.inVpid, $scope.selectDoctor.DOCTOR_CODE, "", "0", 0, "", "", "").then(function (data) {
                if (data.result == 1) {
                    // 存一下病情信息Id，用于后面点提交使用
                    $scope.infomationId = data.data;
                    UploadImage($scope.infomationId, imageDataList, 0);
                }
                else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
            }, function () {
                $fwCordovaToast.showShortBottom("网络错误");
                $ionicLoading.hide();
            })
        }
        // 有病情信息ID，证明是保存复用的
        else {
            UploadImage($scope.infomationId, imageDataList, 0);
        }

    }

    // 批量上传图片
    function UploadImage(infomationId, imageDataList, index) {
        // 上传图片参数
        var options = new FileUploadOptions();
        options.fileKey = "fileAddPic";
        options.fileName = imageDataList[index].substr(imageDataList[index].lastIndexOf("/") + 1);
        options.mimeType = "text/plain";
        options.params = { urlExt: infomationId };
        // 上传图片路径
        var uri = encodeURI(uploadUrl + "/UploadHandler.ashx");
        // 显示上传等待
        if (index == 0) {
            $ionicLoading.show();
        }
        // 上传图片
        $cordovaFileTransfer.upload(uri, imageDataList[index], options, true).then(function (result) {
            // 成功处理
            // 保存已上传图像路径
            $scope.imageAddSave(result.response);
            // 递归调用
            if (imageDataList.length > index + 1) {
                UploadImage(infomationId, imageDataList, index + 1);
            }
        }, function (error) {
            // 错误处理
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("上传失败，错误：" + error + "。请稍后重试");
            // 递归调用
            if (imageDataList.length > index + 1) {
                UploadImage(infomationId, imageDataList, index + 1);
            }
        }, function (progress) {
            ;
        });
    }

    // 保存已上传图像路径
    $scope.imageAddSave = function (path) {
        // 保存数据
        UploadImgService.imgAdd("BY_CONSULTATION", $scope.infomationId, '', path, '').then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            } else {
                $scope.infomation.imgList.push(data.data);
            }
            $ionicLoading.hide();
        });
    }

    // 显示图片删除按钮
    $scope.showImgDelete = function () {
        for (var i = 0; i < $scope.infomation.imgList.length; i++) {
            $scope.infomation.imgList[i].isImgDelete = true;
        }
    }

    // 隐藏图片删除按钮
    $scope.cancelImgDelete = function () {
        for (var i = 0; i < $scope.infomation.imgList.length; i++) {
            $scope.infomation.imgList[i].isImgDelete = false;
        }
    }

    // 删除图片
    $scope.imgDelete = function (id) {
        console.log(id);
        $ionicPopup.confirm({
            title: "删除检查资料",
            template: "您确定要删除该资料图片？",
            cancelText: "取消",
            okText: "确定删除"
        }).then(function (res) {
            if (res) {
                UploadImgService.imgDelete(id).then(function (data) {
                    if (data.result == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    } else {
                        for (var i = 0; i < $scope.infomation.imgList.length; i++) {
                            if ($scope.infomation.imgList[i].UPLOAD_IMG_ID == id) {
                                $scope.infomation.imgList.splice(i, 1);
                            }
                        }
                    }
                    $ionicLoading.hide();
                })
            }
            $scope.showImgDelete();
        });
    }

    // 显示弹出大图
    $scope.popupImgShow = function (list, index) {
        $ionicModal.fromTemplateUrl("popup_image.html", {
            scope: $scope,
            animation: "fade-in"
        }).then(function (modal) {
            $scope.popupImageModal = modal;
            // 赋值图片列表
            $scope.uploadImgList = list;
            var cIndex = index;
            var preIndex = index == 0 ? list.length - 1 : index - 1;
            var nextIndex = index == list.length - 1 ? 0 : index + 1;

            $scope.currentImgIndex = cIndex;
            $scope.currentSlideIndex = 1;

            $scope.slides[0] = { src: list[preIndex].URL, seq: preIndex };
            $scope.slides[1] = { src: list[cIndex].URL, seq: cIndex };
            $scope.slides[2] = { src: list[nextIndex].URL, seq: nextIndex };
            //$ionicSlideBoxDelegate.$getByHandle("popup_image_slides").update();
            // 显示弹出层
            $scope.popupImageModal.show();
        });
    }

    // 隐藏弹出大图
    $scope.popupImgHide = function () {
        // 清空图片列表
        $scope.uploadImgList = [];
        // 隐藏弹出
        $scope.popupImageModal.hide();
        $scope.popupImageModal.remove();
    }

    // 选中切换
    $scope.popupImgSlideChange = function (index) {
        var change = $scope.currentSlideIndex + ">" + index;
        $scope.currentSlideIndex = index;
        if (change == "2>0" || change == "0>1" || change == "1>2") {
            var sIndex = index + 1;
            if (sIndex == 3) {
                sIndex = 0;
            }
            var iIndex = $scope.slides[index].seq;
            iIndex = iIndex + 1;
            if (iIndex == $scope.uploadImgList.length) {
                iIndex = 0;
            }
            $scope.slides[sIndex] = { src: $scope.uploadImgList[iIndex].URL, seq: iIndex };
        }
        else if (change == "0>2" || change == "2>1" || change == "1>0") {
            var sIndex = index - 1;
            if (sIndex == -1) {
                sIndex = 2;
            }
            var iIndex = $scope.slides[index].seq;
            iIndex = iIndex - 1;
            if (iIndex == -1) {
                iIndex = $scope.uploadImgList.length - 1;
            }
            $scope.slides[sIndex] = { src: $scope.uploadImgList[iIndex].URL, seq: iIndex };
        }
    }

    // 阻止事件冒泡
    $scope.stopPropagation = function () {
        event.stopPropagation();
    }

    // 跳转到医师介绍
    $scope.doctorIntro = function (doctorId, doctorLevel, doctorCode, doctorName, doctorPath, doctorSpeciality) {
        // 医师简介优化，GW没有维护的数据，从前一页拽过来
        if (doctorId == undefined || doctorId.length == 0) {
            var data = new Object();
            data.avatar_path = doctorPath;
            data.description = "";
            data.doctor_code = doctorCode;
            data.doctor_id = doctorId;
            data.doctor_name = doctorName;
            data.speciality = doctorSpeciality;
            data.title = doctorLevel;
            $scope.doctorInfo = data;
        }
        else {
            DoctorInfoService.doctorInfo(doctorId).then(function (data) {
                $scope.doctorInfo = data;
                if (doctorLevel.toString() != "") {
                    $scope.doctorInfo.title = doctorLevel;
                }
            }, function (resp) {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom("加载失败, 请检查网络");
            });
        }
        $scope.doctorIntroModal.show();
        $ionicScrollDelegate.$getByHandle('intro').scrollTop();
    }

    // 医师介绍隐藏
    $scope.doctorIntroHide = function () {
        $scope.doctorIntroModal.hide();
        $scope.schedulingModal = null;
    }

    // 病情描述历史记录显示
    $scope.showInfomationHistory = function () {
        $scope.infomationHistory.show();
    }

    // 病情描述历史记录隐藏
    $scope.hideInfomationHistory = function () {
        $scope.infomationHistory.hide();
    }

    // 选择病情描述
    $scope.selectInfomation = function (index) {
        $ionicPopup.confirm({
            title: "导入确认",
            template: "是否要导入该病情信息？",
            cancelText: "否",
            okText: "是"
        }).then(function (res) {
            if (res) {
                // 通过病情信息Id获取病情信息详情
                $ionicLoading.show();
                ConsultationService.selectInfomation($scope.infomationHistoryList[index].TREAT_INFOMATION_ID).then(function (data) {
                    $scope.infomation.diseaseStr = data.data.DISEASE; // 所患疾病字符串
                    $scope.infomation.infomation = data.data.INFOMATION; // 病情描述
                    $scope.infomation.help = data.data.HELP; // 希望获得的帮助
                    $scope.infomation.visitHospital = data.data.VISIT_HOSPITAL; // 已就诊医院及科室
                    $scope.infomation.isDrug = data.data.IS_DRUG; // 用药情况，1=有，0=无
                    // 如果是资质延长，这里不带入
                    if($scope.fromDivision != 4){
                        $scope.infomation.drug = data.data.DRUG; // 用药情况
                    }
                    else{
                        if($scope.infomation.drugOL != ""){
                            $scope.infomation.drug = data.data.DRUG.replace($scope.infomation.drugOL, "");
                            $scope.infomation.drug = $scope.infomation.drug.replace("。其他用药情况：", "");
                            if($scope.infomation.drug == ""){
                                $scope.infomation.isDrug = 0;
                            }
                        }
                    }
                    $scope.infomation.isAllergy = data.data.IS_ALLERGY; //过敏史，1=有，0=无
                    $scope.infomation.allergy = data.data.ALLERGY; //过敏史
                    $scope.infomation.isPreviousDisease = data.data.IS_PREVIOUS_DISEASE; //既往病史，1=有，0=无
                    $scope.infomation.previousDisease = data.data.PREVIOUS_DISEASE; // 既往病史
                    $scope.infomation.purpose = data.data.PURPOSE;
                    // 2020-5-20 15:55:14 HM 增加监护人信息
                    $scope.infomation.guardianName = data.data.GUARDIAN_NAME;
                    $scope.infomation.guardianPhone = data.data.GUARDIAN_PHONE;
                    $scope.infomation.currentAreaCode = data.data.CURRENT_AREA_CODE;
                    $scope.infomation.disease = data.data.DISEASE_LIST;// 所患疾病列表

                    var purposeStr = new Array();
                    purposeStr = data.data.PURPOSE.split("；");
                    $scope.infomation.purpose = "";
                    for(var i = 0; i < $scope.purposeList.length; i++){
                        // 2020-8-3 09:02:39 HM 如果是药师咨询，就跳过
                        if($scope.purposeList[i].way == "3" || $scope.purposeList[i].way == "4"){
                            continue;
                        }

                        $scope.purposeList[i].status = "0";
                        for(var j = 0; j < purposeStr.length; j++){
                            if(purposeStr[j] == $scope.purposeList[i].name){
                                $scope.purposeList[i].status = "1";
                            }
                        }

                        $scope.purposeOtherShow = false;
                        if($scope.purposeList[i].code == "999" && $scope.purposeList[i].status == "1"){
                            $scope.purposeOtherShow = true;
                        }

                        if($scope.purposeList[i].status == "1"){
                            $scope.infomation.purpose += $scope.purposeList[i].name + "；";
                        }
                    }

                    // 没有病情信息ID
                    if ($scope.infomationId == null || $scope.infomationId.length == 0) {
                        //创建新的病情信息
                        ConsultationService.submitInfomation("", "", "", "", 0,
                        "", 0, "", 0, "", "",
                        $scope.inVpid, $scope.selectDoctor.DOCTOR_CODE, "", "0", 0, "", "", "").then(function (dataInfomation) {
                            // 创建成功
                            if (dataInfomation.result == 1) {
                                // 存一下病情信息Id
                                $scope.infomationId = dataInfomation.data;
                                // 复制图片，新创建的id，和旧的导入的id
                                ConsultationService.copyImg($scope.infomationId, $scope.infomationHistoryList[index].TREAT_INFOMATION_ID).then(function (dataCopy){
                                    $ionicLoading.hide();
                                    if(dataCopy.result == 1){
                                        $scope.infomation.imgList = dataCopy.data;
                                        $ionicScrollDelegate.resize();
                                    }
                                    else{
                                        $fwCordovaToast.showShortBottom(dataCopy.msg);
                                    }
                                }, function () {
                                    $fwCordovaToast.showShortBottom("网络错误");
                                    $ionicLoading.hide();
                                })
                            }
                            // 创建失败
                            else {
                                $fwCordovaToast.showShortBottom(dataInfomation.msg);
                                $ionicLoading.hide();
                            }
                        }, function () {
                            $fwCordovaToast.showShortBottom("网络错误");
                            $ionicLoading.hide();
                        })
                    }
                    // 有病情信息ID
                    else {
                        UploadImgService.imgList("BY_CONSULTATION", $scope.infomationId).then(function (dataImg) {
                            $ionicLoading.hide();
                            if (data.result == 0) {
                                $fwCordovaToast.showShortBottom(dataImg.msg);
                            } else {
                                $scope.infomation.imgList = dataImg.data;
                                $ionicScrollDelegate.resize();
                            }
                        }, function () {
                            $fwCordovaToast.showShortBottom("网络错误");
                            $ionicLoading.hide();
                        })
                    }

                    $scope.hideInfomationHistory();
                }, function () {
                    $fwCordovaToast.showShortBottom("网络错误，导入失败");
                    $ionicLoading.hide();
                    // 回选择预约方式页
                    if($scope.chooseDoctor == true){
                        $scope.toSlide(0);
                    }
                    else{
                        $scope.toSlide(2);
                    }
                })
            }
        });
    }

    // 放大显示头像模态窗口显示
    $scope.showAvatarShow = function (url) {
        if (url.indexOf('Default.jpg') > -1) {
            return;
        }
        //console.log(url);
        //$scope.avatarUrl = 'img/R20130003.JPG';
        $scope.avatarUrl = url;
        $scope.showAvatarModal.show();
    }

    // 放大显示头像模态窗口隐藏
    $scope.showAvatarHide = function () {
        $scope.showAvatarModal.hide();
        $scope.avatarUrl = "";
    }

    // 隐藏问卷填写信息
    $scope.hideTmpl = function () {
        $scope.srvyModal.hide();
    }

    // 保存问卷结果
    $scope.saveResult = function () {
        $ionicLoading.show();
        SrvyService.saveRecord($scope.tmplInfo.id, $scope.currentRec, $scope.inVpid, $scope.srvyResult).then(function (data) {
            if (data.result == 1) {
                $fwCordovaToast.showShortBottom("问卷填写完成！");
                // 初始化题目信息（防止再次进入显示混乱）
                $scope.tmpl = new Object();
                $scope.tmplInfo = new Object();
                $scope.qstnCount = 0;

                $scope.hideTmpl();

                $ionicLoading.hide();

                // 将recId回写infomation吧，关联
                ConsultationService.writeBackRecId(data.recId, $scope.infomationId).then(function (dataBack) {
                    $ionicLoading.hide();
                    if(dataBack.result == 1){
                        // 回写成功之后，跳转
                        $scope.toSlide(4);
                    }
                    else{
                        $fwCordovaToast.showShortBottom(dataBack.msg);
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("回写RECID失败");
                    $ionicLoading.hide();
                })
            } else {
                $ionicLoading.hide();
                $fwCordovaToast.showShortBottom(data.msg);
            }
        });
    }

    // 咨询目的checkbox变换
    $scope.purposeCheckBox = function (code) {
        // 每点击一次，都重置一次
        $scope.infomation.purpose = "";
        for (var i = 0; i < $scope.purposeList.length; i++) {
            if ($scope.purposeList[i].code == code) {
                // 2020-7-31 18:17:59 HM 如果是药师咨询，不让选
                if($scope.purposeList[i].way.indexOf("3") != -1 || $scope.purposeList[i].way.indexOf("4") != -1){
                    return;
                }

                if ($scope.purposeList[i].status == "1") {
                    $scope.purposeList[i].status = "0";
                }
                else {
                    $scope.purposeList[i].status = "1";
                }
            }

            if (code == "999" && $scope.purposeList[i].status == "1") {
                $scope.purposeOtherShow = true;
            }
            else if (code == "999" && $scope.purposeList[i].status != "1") {
                $scope.purposeOtherShow = false;
                $scope.infomation.help = "";
            }

            if ($scope.purposeList[i].status == "1") {
                $scope.infomation.purpose += $scope.purposeList[i].name + "；";
            }
        }
        $ionicScrollDelegate.resize();
    }

    // 切换选择预约方式
    $scope.apptMethod = function (index) {
        // 初始化一下筛选条件
        $scope.doctorDivision.code = "";
        $scope.doctorDivision.name = "";
        $scope.showAvailable = false;
        $scope.doctorSearch.keyword = "";
        // 初始化一下默认选择的科别，不初始化的话，都去查了心内科
        $scope.divisionCode = "";
        // 先给个默认的，然后再改
        $scope.groupTitleName = "在线问诊";
        $scope.group = {};

        // 按科室预约
        if (index == 1) {
            $scope.fromDivision = 1;
            // 默认选择心内科
            $scope.divisionCode = $scope.configData.divisionList[0].code;
            $scope.loadDoctorList();
            // 直接选医生
            $scope.toSlide(2);
            $scope.titleName = "选择问诊医生";
        }
        else if(index == 2){
            $scope.fromDivision = 2;
            // 先选一下病区
            $scope.toSlide(1);
            $scope.groupTitleName = "选择病区";
            $scope.titleName = "选择问诊医生";
        }
        else if(index == 3){
            // 药师咨询仅限3个月内曾在我院就诊或开药的患者。
            $ionicLoading.show();
            RequestService.getOpDrug($scope.inVpid, localStorage.queryToken).then(function (data) {
                if (data.result == 99) {    // 链接超时
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("连接超时，请重试");
                    return;
                }
                if (data.result == -2) {    // 需要输入查询密码
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom("连接超时，请重试");
                    return;
                }
                if (data.result != 1 && data.result != -1) {  // 请求错误
                    $ionicLoading.hide();
                    $fwCordovaToast.showShortBottom(data.msg);
                    return;
                }
                if (data.result == -1) {        // 请求缓存
                    $timeout(function () {
                        if (data.is_null != 1) {
                            if($scope.configData.pharmacistContent != ""){
                                $ionicPopup.alert({
                                    title: '提示',
                                    template: $scope.configData.pharmacistContent,
                                    okText: "确定"
                                }).then(function () {
                                    $scope.fromDivision = 3;
                                    $scope.loadDoctorList();
                                });
                            }
                            else{
                                $scope.fromDivision = 3;
                                $scope.loadDoctorList();
                            }
                        }
                        $ionicLoading.hide();
                    }, 1500);
                }

                if (data.is_null != 1) {
                    $ionicLoading.hide();
                    if($scope.configData.pharmacistContent != ""){
                        $ionicPopup.alert({
                            title: '提示',
                            template: $scope.configData.pharmacistContent,
                            okText: "确定"
                        }).then(function () {
                            $scope.fromDivision = 3;
                            $scope.loadDoctorList();
                        });
                    }
                    else{
                        $scope.fromDivision = 3;
                        $scope.loadDoctorList();
                    }
                } else {
                    $fwCordovaToast.showLongBottom($scope.configData.pharmacistToast);
                    $ionicLoading.hide();
                }
            });
            $scope.titleName = "选择问诊药师";
        }
        else if(index == 4){
            // 复诊续方资质延长，同在线问诊
            $scope.fromDivision = 4;
            $scope.loadDoctorList();
            // 直接选医生
            $scope.toSlide(2);
            $scope.titleName = "选择资质延长医生";
        }
        // 按病种预约
        else if(index == 5){
            $scope.fromDivision = 5;
            // 选病种，重新赋值。
            // 获取病种
            $ionicLoading.show();
            OpApptService.getSpecialityGroupList("BZ").then(function (data){
                $ionicLoading.hide();
                if(data.result == 0){
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                else{
                    $scope.configData.bzGroup = data.data.groupList;
                    $scope.groupTitleName = data.data.title;
                    $scope.titleName = "选择问诊医生";
                    $scope.toSlide(1);
                }
            }, function () {
                $fwCordovaToast.showShortBottom("网络错误");
                $ionicLoading.hide();
            })
        }
        // 按特色技术预约
        else if(index == 6){
            $scope.fromDivision = 6;
            // 选技术，重新赋值
            // 获取技术
            $ionicLoading.show();
            OpApptService.getSpecialityGroupList("JS").then(function (data){
                $ionicLoading.hide();
                if(data.result == 0){
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                else{
                    $scope.configData.jsGroup = data.data.groupList;
                    $scope.groupTitleName = data.data.title;
                    $scope.titleName = "选择问诊医生";
                    $scope.toSlide(1);
                }
            }, function () {
                $fwCordovaToast.showShortBottom("网络错误");
                $ionicLoading.hide();
            })
        }
    }

    // 选择病区
    $scope.selectDoctorDivision = function (index) {
        $scope.doctorDivision.code = $scope.configData.doctorDivisionList[index].code;
        $scope.doctorDivision.name = $scope.configData.doctorDivisionList[index].name;
        $scope.loadDoctorList();
        $scope.toSlide(2);
    }

    // 返回
    $scope.goBack = function () {
        // 病情描述
        if ($scope.step == 3) {
            // 先判断是否什么都没填，如果什么都没填，直接返回，不存储
            if ($scope.infomation.disease.length == 0 && $scope.infomation.infomation == "" && $scope.infomation.purpose == "" && $scope.infomation.visitHospital == "" &&
            $scope.infomation.drug == "" && $scope.infomation.allergy == "" && $scope.infomation.previousDisease == "" && $scope.infomation.guardianName == "" && $scope.infomation.guardianPhone == "") {
                
                // 回选择预约方式页
                if($scope.chooseDoctor == true){
                    $scope.toSlide(0);
                }
                else{
                    $scope.toSlide(2);
                }
            }
            else {
                $ionicPopup.confirm({
                    title: "保存确认",
                    template: "是否要保存已经填写的病情信息？",
                    cancelText: "否",
                    okText: "是"
                }).then(function (res) {
                    if (res) {
                        $ionicLoading.show();
                        // 向库插入病情信息,infomationId有可能为空，有可能不为空，为空的是为纯萌新填写，不为空的为复用之前的。
                        if($scope.infomation.purpose.charAt($scope.infomation.purpose.length - 1) == "；"){
                            $scope.infomation.purpose = $scope.infomation.purpose.substr(0, $scope.infomation.purpose.length - 1);
                        }
                        
                        var diseaseString = "";
                        for (var i= 0; i < $scope.infomation.disease.length; i++) {
                            if ($scope.infomation.disease[i].RECS_CODE.length != 0) {
                                diseaseString += $scope.infomation.disease[i].DISEASE_NAME + "@" + $scope.infomation.disease[i].RECS_CODE + "|";
                            }
                            else if ($scope.infomation.disease[i].DISEASE_NAME.length != 0){
                                diseaseString += $scope.infomation.disease[i].DISEASE_NAME + "@0|";
                            }
                        }
                        diseaseString = diseaseString.substr(0, diseaseString.length - 1);

                        // 如果是复诊续方资质延长
                        if ($scope.fromDivision == 4) {
                            $scope.infomation.isDrug = 1;
                            if ($scope.infomation.drug != "" && $scope.infomation.drug.length > 0) {
                                var drugStr = $scope.infomation.drugOL + "\r\n";
                                drugStr += "其他用药情况：\r\n";
                                drugStr += $scope.infomation.drug;
                                $scope.infomation.drug = drugStr;
                            }
                            else {
                                $scope.infomation.drug = $scope.infomation.drugOL;
                            }
                        }

                        ConsultationService.submitInfomation(diseaseString, $scope.infomation.infomation, $scope.infomation.help, $scope.infomation.visitHospital, $scope.infomation.isDrug,
                        $scope.infomation.drug, $scope.infomation.isAllergy, $scope.infomation.allergy, $scope.infomation.isPreviousDisease, $scope.infomation.previousDisease, $scope.infomation.purpose,
                        $scope.inVpid, $scope.selectDoctor.DOCTOR_CODE, $scope.infomationId, "0", $scope.vpInfo.IS_GUARDIAN, $scope.infomation.guardianName, $scope.infomation.guardianPhone, $scope.infomation.currentAreaCode).then(function (data) {
                            $ionicLoading.hide();
                            if (data.result == 1) {
                                $fwCordovaToast.showShortBottom("保存成功");
                            }
                            else {
                                $fwCordovaToast.showShortBottom(data.msg + "，保存失败");
                            }
                            // 回选择预约方式页
                            if($scope.chooseDoctor == true){
                                $scope.toSlide(0);
                            }
                            else{
                                $scope.toSlide(2);
                            }
                        }, function () {
                            $fwCordovaToast.showShortBottom("网络错误，保存失败");
                            $ionicLoading.hide();
                            // 回选择预约方式页
                            if($scope.chooseDoctor == true){
                                $scope.toSlide(0);
                            }
                            else{
                                $scope.toSlide(2);
                            }
                        })
                    }
                    else {
                        // 回选择预约方式页
                        if($scope.chooseDoctor == true){
                            $scope.toSlide(0);
                        }
                        else{
                            $scope.toSlide(2);
                        }
                    }
                });
            }
        }
        // 支付确认
        else if ($scope.step == 4) {
            // 回选择预约方式页
            if($scope.chooseDoctor == true){
                $scope.toSlide(0);
            }
            else{
                $scope.toSlide(2);
            }
        }
        // 选择医生
        else if ($scope.step == 2) {
            if($scope.fromDivision == 1 || $scope.fromDivision == 3){
                $scope.toSlide(0);
            }
            else if($scope.fromDivision == 2 || $scope.fromDivision == 5 || $scope.fromDivision == 6){
                $scope.toSlide(1);
            }
            else if($scope.fromDivision == 4){
                $state.go("app.olTreatRecipe", { from: "consultation" });
            }
        }
        // 选择病区
        else if ($scope.step == 1) {
            $scope.toSlide(0);
        }
        else {
            if($scope.step == 0 && $stateParams.from.indexOf('autoInquiry') > -1){
                $state.go("app.autoInquiry", {vpid: $stateParams.vpid, firstFrom: $stateParams.autoFirstFrom, continueInquiry: 1});
            }
            else {
                $state.go('app.home');
            }
        }
    }

    // 所患疾病显示
    $scope.showInfomationDisease = function () {
        $scope.infomationDiseaseModal.show();
    }

    // 所患疾病隐藏
    $scope.hideInfomationDisease = function () {
        $scope.infomation.diseaseStr = "";
        for(var i=0;i<$scope.infomation.disease.length;i++){
            $scope.infomation.diseaseStr += $scope.infomation.disease[i].DISEASE_NAME + "，";
        }
        $scope.infomation.diseaseStr = $scope.infomation.diseaseStr.substr(0, $scope.infomation.diseaseStr.length - 1);
        $scope.infomationDiseaseModal.hide();
    }

    // 添加所患疾病
    $scope.addDisease = function (disease, index) {
        var temp = {};
        temp.RECS_CODE = disease.RECS_CODE;
        temp.DISEASE_NAME = disease.DISEASE_NAME;

        if($scope.diseaseIsSelected(temp) == true){
            // 提示
            $ionicPopup.alert({
                title: "提示",
                template: "您已选择该项，请选择其他疾病",
                okText: "确定"
            }).then(function (res) {
                ;
            });
        }
        else{
            // 没有诊断，就添加
            $scope.infomation.disease.push(temp);
            console.log($scope.infomation.disease);

            if(index == 2){
                $scope.hideAddDisease();
            }
        }
    }

    // 判断所患疾病是否已选中
    $scope.diseaseIsSelected = function (disease){
        var flag = false;
        if($scope.infomation.disease.length > 0){
            $scope.infomation.disease.forEach(item => {
                if(item.RECS_CODE == disease.RECS_CODE){
                    flag = true;
                }
            });
        }
        return flag;
    }

    // 删除所患疾病
    $scope.deleteDisease = function (index) {
        $scope.infomation.disease.splice(index, 1);
    }

    // 搜索所患疾病显示
    $scope.showAddDisease = function (){
        if ($scope.infomation.disease.length >= 20) {
            $fwCordovaToast.showShortBottom('您选择的疾病过多');
            return;
        }
        $scope.addDiseaseData.keyword = "";
        $scope.addDiseaseData.results = [];
        $scope.addDiseaseModal.show();
        // 自动获取焦点
        $timeout(function () {
            document.getElementById("searchDisease").focus();
        }, 500);
    }

    // 搜索所患疾病隐藏
    $scope.hideAddDisease = function (){
        $scope.addDiseaseModal.hide();
    }

    // 搜索所患疾病
    $scope.searchDisease = function () {
        $scope.addDiseaseData.results = [];
        $ionicLoading.show();
        ConsultationService.searchDisease($scope.addDiseaseData.keyword, $scope.inVpid).then(function (data){
            // 查询成功
            if (data.result == 1) {
                $scope.addDiseaseData.results = data.data;
                $ionicScrollDelegate.scrollTop();
            }
            // 无结果
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            $ionicLoading.hide();
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("搜索超时，请稍后再试");
        });
    }

    // 根据requestId查询患者上一次就诊诊断
    $scope.getDiseaseResp = function (requestId){
        ConsultationService.getDiseaseResp(requestId).then(function (data){
            $scope.requestNum++;
            // 2020-12-21 10:19:49 HM 这里request比较多，有异步的，都走完后，要消loading
            if($scope.requestNum == 2){
                $ionicLoading.hide();
            }

            // 查询成功
            if(data.result == 1){
                // 判断是否结果是否空
                if(data.is_null == 0){
                    // 不为空，前来赋值
                    $scope.infomation.disease = data.data.diseaseList;
                    $scope.infomation.diseaseStr = data.data.diseaseStr;
                }
                // 结果空，应该是什么都不处理
                else {
                    console.log("结果是空的，应该什么都不用管");
                }
            }
            else{
                $fwCordovaToast.showShortBottom("获取上一次诊断失败");
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("获取上一次诊断失败，请稍后再试");
        });
    }

    // 知情同意书显示
    $scope.informedConsentShow = function () {
        $scope.informedConsentModal.show();
    }

    // 知情同意书关闭
    $scope.informedConsentHide = function () {
        $scope.informedConsentModal.hide();
    }

    // 拿门诊药品
    $scope.getOpDrug = function (){
        $scope.drugRadioShow = false;

        // 如果不是复诊续方资质延长直接踢回
        if($scope.fromDivision != 4){
            $scope.requestNum++;
            // 2020-12-21 10:19:49 HM 这里request比较多，有异步的，都走完后，要消loading
            if($scope.requestNum == 2){
                $ionicLoading.hide();
            }
            return;
        }

        $scope.infomation.drugOL = "";
        RequestService.getOpDrug($scope.inVpid, localStorage.queryToken).then(function (data) {
            $scope.requestNum++;
            // 2020-12-21 10:19:49 HM 这里request比较多，有异步的，都走完后，要消loading
            if($scope.requestNum >= 2){
                $ionicLoading.hide();
            }

            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {    // 需要输入查询密码
                $scope.getOpDrug();
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.result == -1) {        // 请求缓存
                $timeout(function () {
                    if (data.is_null != 1) {
                        var drugListStr = "";

                        // 2020-12-21 11:03:51 HM 修改一下显示格式，分别展示可开药与不可开药列表
                        // 拆出两个数组
                        var yesList = data.data.filter(item => item.REMARKS != "该药品不支持在线复诊续方");
                        var noList = data.data.filter(item => item.REMARKS == "该药品不支持在线复诊续方");

                        drugListStr += "复诊续方药品：\r\n";
                        for(var i = 0; i < yesList.length; i++){
                            drugListStr += yesList[i].DRUG_NAME + "，" + yesList[i].DRUG_USAGE + "\r\n";
                        }

                        if(noList.length > 0){
                            drugListStr += "\r\n";
                            drugListStr += "不支持复诊续方申请药品：\r\n";
                            for(var i = 0; i < noList.length; i++){
                                drugListStr += noList[i].DRUG_NAME + "，" + noList[i].DRUG_USAGE + "\r\n";
                            }
                        }
                        if(drugListStr != ""){
                            $scope.drugRadioShow = true;
                            $scope.infomation.drugOL = drugListStr;
                        }
                    }
                }, 500);
            }
            if (data.is_null != 1) {
                var drugListStr = "";
                // 2020-12-21 11:03:51 HM 修改一下显示格式，分别展示可开药与不可开药列表
                // 拆出两个数组
                var yesList = data.data.filter(item => item.REMARKS != "该药品不支持在线复诊续方");
                var noList = data.data.filter(item => item.REMARKS == "该药品不支持在线复诊续方");

                drugListStr += "复诊续方药品：\r\n";
                for(var i = 0; i < yesList.length; i++){
                    drugListStr += yesList[i].DRUG_NAME + "，" + yesList[i].DRUG_USAGE + "\r\n";
                }

                if(noList.length > 0){
                    drugListStr += "\r\n";
                    drugListStr += "不支持复诊续方申请药品：\r\n";
                    for(var i = 0; i < noList.length; i++){
                        drugListStr += noList[i].DRUG_NAME + "，" + noList[i].DRUG_USAGE + "\r\n";
                    }
                }
                if(drugListStr != ""){
                    $scope.drugRadioShow = true;
                    $scope.infomation.drugOL = drugListStr;
                }
                console.log(drugListStr);
            } else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("获取复诊续方药品失败，请稍后再试");
        });
    }

    // 页面切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
        //$fwCordovaToast.showShortBottom("step: " + $scope.step);
    }

    // 选择病种/特色技术
    $scope.selectGroup = function (groupCode, groupType) {
        // 这里其实可以用1个数组，但是为了区分吧，写成两个
        if(groupType == "BZ"){
            // 病种的数组
            var item = $scope.configData.bzGroup.filter(e => e.GROUP_CODE == groupCode)[0];
            $scope.group = item;

            if(typeof item.SUBGROUP_LIST == "undefined"){
            }
            else{
                $scope.group.GROUP_CODE = item.SUBGROUP_LIST[0].GROUP_CODE;
            }
        }
        else if(groupType == "JS"){
            // 技术的数组
            var item = $scope.configData.jsGroup.filter(e => e.GROUP_CODE == groupCode)[0];
            $scope.group = item;
            if(typeof item.SUBGROUP_LIST == "undefined"){
            }
            else{
                $scope.group.GROUP_CODE = item.SUBGROUP_LIST[0].GROUP_CODE;
            }
        }

        // 加载医师列表
        $scope.loadDoctorList();
        // 直接选医生
        $scope.toSlide(2);
    }

    // 切换治疗方式
    $scope.changeSpecialitySubgroup = function (groupCode){
        $scope.group.GROUP_CODE = groupCode;
        // 加载医师列表
        $scope.loadDoctorList();
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideConsultation.enableSlide(false);
    });

    $scope.$on('$ionicView.enter', function () {
        $ionicLoading.show();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'consultation');

        ConsultationService.visitPatientInfo($scope.inVpid).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;

                ConsultationService.getConfig().then(function (conData) {
                    if (conData.result == 0) {
                        $fwCordovaToast.showShortBottom(conData.msg);
                    }
                    else {
                        $scope.configData = conData.data;
                        $scope.purposeList = $scope.configData.helpList;
                        // 页面进入
                        $scope.isLoadFinish = true;
                        ConsultationService.consultationStatus($scope.inVpid, "").then(function (statusData){
                            $ionicLoading.hide();
                            if(statusData.result == 0){
                                $fwCordovaToast.showShortBottom(statusData.msg);
                            }
                            // 有会话
                            else if(statusData.result == 1){
                                var confirmPopup = $ionicPopup.confirm({
                                    title: "您当前存在进行中的咨询，是否进入会话继续咨询？",
                                    cancelText: '取消',
                                    okText: '进入'
                                });
                                // 进入会话，调用易复诊SDK
                                confirmPopup.then(function (res) {
                                    if (res) {
                                        var param = {
                                            accountSourceId: $scope.vpInfo.ACCOUNT_ID,
                                            accountId: $scope.inVpid,
                                            patientName: $scope.vpInfo.VISIT_PATIENT_NAME,
                                            patientSex: $scope.vpInfo.SEX == '1' ? "男" : "女",
                                            patientBirthday: $scope.vpInfo.BIRTHDAY.slice(0, 10),
                                            patientHeadPic: $scope.vpInfo.HEAD_PIC,
                                            patientPhoneNo: $scope.vpInfo.PHONE_NUM,
                                            doctorId: statusData.doctorCode, // 四位医师代码
                                            doctorEmployeeCardNo: statusData.staffNumber, // 胸卡号
                                            hospitalOrderId: statusData.applyId,
                                            fuzhen: $scope.IsConsultation
                                        };

                                        var funcSuccess = function (funcData) {
                                            console.log('百洋：toChat 调用成功');
                                            console.log(funcData);
                                        }

                                        var funcError = function (funcData) {
                                            console.log('百洋：toChat 调用失败');
                                            console.log(funcData);
                                        }
                                        window.plugins.EasyChatPlugin.toChat(param, funcSuccess, funcError);
                                    }
                                    else{
                                        // 如果来自复诊续方资质延长
                                        if($stateParams.from.indexOf('olCondition') > -1){
                                            $scope.apptMethod(4);
                                        }
                                    }
                                })
                            }
                            else{
                                // 如果来自复诊续方资质延长
                                if($stateParams.from.indexOf('olCondition') > -1){
                                    $scope.apptMethod(4);   
                                }
                            }
                        }, function () {
                            $fwCordovaToast.showShortBottom("获取会话状态：网络错误");
                            $ionicLoading.hide();
                        })
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("网络错误");
                    $ionicLoading.hide();
                })
            }
        }, function () {
            $fwCordovaToast.showShortBottom("网络错误");
            $ionicLoading.hide();
        })
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'consultation') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
